![logo](https://libgdx.com/assets/images/logo.png)

[![GitHub Actions build status](https://img.shields.io/github/workflow/status/libgdx/libgdx/Java%20CI%20with%20Gradle/master?label=GitHub%20Actions)](https://github.com/libgdx/libgdx/actions?query=workflow%3A%22Build+Snapshot%22)

[![Sonatype Nexus (Releases)](https://img.shields.io/nexus/r/com.badlogicgames.gdx/gdx?nexusVersion=2&server=https%3A%2F%2Foss.sonatype.org&label=version)](https://search.maven.org/artifact/com.badlogicgames.gdx/gdx)
[![Sonatype Nexus (Snapshots)](https://img.shields.io/nexus/s/com.badlogicgames.gdx/gdx?server=https%3A%2F%2Foss.sonatype.org&label=snapshot)](https://oss.sonatype.org/#nexus-search;gav~com.badlogicgames.gdx~gdx~~~~kw,versionexpand)

[![Discord Chat](https://img.shields.io/discord/348229412858101762?logo=discord)](https://libgdx.com/community/discord/)

## Cross-platform Game Development Framework
**[libGDX](https://libgdx.com) is a cross-platform Java game development framework based on OpenGL (ES) that works on Windows, Linux, Mac OS X, Android, iOS and your WebGL enabled browser.** It provides a well-tried and robust environment for rapid prototyping and fast iterations. LibGDX does not force a specific design or coding style on you, it rather gives you the freedom to create a game the way you like it.

## Open Source, Feature Packed and Offering a Big Third-Party Ecosystem
libGDX is licensed under [Apache 2.0](https://www.apache.org/licenses/LICENSE-2.0.html) meaning you can use it free of charge, without strings attached in commercial and non-commercial projects. We, however, love to get (non-mandatory) credit in case you release a game or app using libGDX! See our [showcase](https://libgdx.com/showcase/) for a selection of some popular libGDX games. libGDX comes with [batteries included](https://libgdx.com/features/) and provides everything required to develop multi-platform 2D and 3D games with Java.

libGDX also offers a very extensive third-party ecosystem. There are numerous [tools](https://libgdx.com/dev/tools/) and libraries that take a lot of work off the hands of developers. Take a look at [awesome-libgdx](https://github.com/rafaskb/awesome-libgdx#readme) for a curated list of libGDX-centered libraries and a good starting point for anyone new in the libGDX world.

![](https://libgdx.com/assets/images/index_showcase/game0.png)
###### An example for a game created with libGDX: [Pathway](https://store.steampowered.com/app/546430/Pathway/) by Robotality. Find more games in our [Showcase](https://libgdx.com/showcase/).

## Getting libGDX / Documentation
As we switched to Gradle, there's no need to download libGDX itself anymore: this can all be done by your favorite build tool. We also offer a [setup tool](https://libgdx.com/dev/#how-to-get-started-with-libgdx), which automatically creates a project for you and downloads everything necessary. See our **[website](https://libgdx.com/dev/setup/)** for instructions on how to get started with this or read our **[wiki](https://github.com/libgdx/libgdx/wiki)**.

- [Creating a libGDX Project](https://libgdx.com/dev/setup/)
- [A Simple Game](https://libgdx.com/dev/simple_game/)
- [Tutorials & Demos](https://libgdx.com/dev/tutorials/)

We also provide [javadocs](https://libgdx.badlogicgames.com/nightlies/docs/api/) online. The javadocs are also bundled as source Jars with every libGDX distribution for consumption in your favorite IDE.

## Community & Contributing
You can follow the **latest news** about libGDX on our [blog](https://libgdx.com/news/). Another good way to get in touch with our community is to join the official [libGDX Discord](https://libgdx.com/community/discord/).

### Reporting Issues
Use the **[Issue Tracker](https://github.com/libgdx/libgdx/issues)** here on GitHub to report issues. Please make sure you read the [Getting Help](https://github.com/libgdx/libgdx/wiki/Getting-help) article that walks you through the process of properly reporting an issue.

### Working on the Code
libGDX has a strong developer community constantly improving the code base. We love to get any and all help we can. Our [Contributing Guidelines](https://libgdx.com/dev/contributing/) describe the process of helping libGDX to become even better. To contribute, you need to work with libGDX' sources directly, something normal users do not have to go through. The [Working with the Source](https://libgdx.com/dev/from_source/) article will give you some directions.

You can also contribute financially to our infrastructure (build server, web server, test devices) via our [Patreon](https://patreon.com/libgdx)!

### Supported By
libGDX is supported by helpful 3rd parties via code contributions, free licenses, test devices and so forth. Make our supporters happy and visit their sites!

<table>
<tr>
<td style="text-align: center;"><a href="https://github.com/MobiVM/robovm"><img style="margin-right:20px" src="https://libgdx.com/assets/images/sponsors/robovm.png" alt="RoboVM" /></a></td>
<td style="text-align: center;"><a href="https://bit.ly/spinegdx"><img src="https://libgdx.com/assets/images/sponsors/spine.png"></a></td>
</tr>

<tr>
<td style="text-align: center;"><a href="https://bit.ly/saikoagdx"><img style="margin-right:20px" src="https://libgdx.com/assets/images/sponsors/saikoa.png" alt="Saikoa" /></a></td>
<td style="text-align: center;"><a href="https://bit.ly/intelgdx"><img src="https://libgdx.com/assets/images/sponsors/intel.png" alt="intel Software Partner" /></a></td>
</tr>

<tr>
<td style="text-align: center;"><img style="margin-right:20px" src="https://libgdx.com/assets/images/sponsors/excelsior.png" alt="Excelsior JET"></td>
<td style="text-align: center;"><img src="https://libgdx.com/assets/images/sponsors/nextpeer.png"></td>
</tr>
</table>

###### Intel and the Intel logo are trademarks of Intel Corporation in the U.S. and/or other countries.
